/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Options;

/**
* \class SOSOptionTime 
* 
* \brief SOSOptionTime - 
* 
* \details
* 
*         <note language="en">
          <div xmlns="http://www.w3.org/1999/xhtml">
Specifies the minimum age of one or multiple files.
If the files is newer then it is classified as non-existing.<br/>
<br/>
Possible values:<br/>
0 (disabled)<br/>
seconds<br/>
hours:minutes<br/>
hours:minutes:seconds
          </div>
        </note>

        <note language="de">
          <div xmlns="http://www.w3.org/1999/xhtml">
Vereinbart das Mindestalter einer oder mehrerer Dateien.
Ist eine Datei jnger, dann gilt sie als nicht vorhanden.<br/>
<br/>
Mgliche Werte sind:<br/>
0 (parameter wird ignoriert)<br/>
Sekunden<br/>
Stunden:Minuten<br/>
Stunden:Minuten:Sekunden
					</div>
        </note>

* \section SOSOptionTime.java_intro_sec Introduction
*
* \section SOSOptionTime.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id: SOSOptionTime.java 14729 2011-07-05 20:47:16Z sos $28.08.2010
* \see reference
*
* Created on 28.08.2010 22:36:43
 */

/**
 * @author KB
 *
 */
public class SOSOptionTime extends SOSOptionString {

	@SuppressWarnings("unused")
	private final String	conClassName	= "SOSOptionTime";

	/**
	 * \brief SOSOptionTime
	 *
	 * \details
	 *
	 * @param pPobjParent
	 * @param pPstrKey
	 * @param pPstrDescription
	 * @param pPstrValue
	 * @param pPstrDefaultValue
	 * @param pPflgIsMandatory
	 */
	public SOSOptionTime(JSOptionsClass pPobjParent, String pPstrKey, String pPstrDescription, String pPstrValue, String pPstrDefaultValue,
			boolean pPflgIsMandatory) {
		super(pPobjParent, pPstrKey, pPstrDescription, pPstrValue, pPstrDefaultValue, pPflgIsMandatory);
	}

	/**
	 * 
	 * \brief getTimeAsSeconds
	 * 
	 * \details
	 *
	 * \return int
	 *
	 * @return
	 */
	public int getTimeAsSeconds() {
		int intSeconds = 0;
		int[] intM = { 1, 60, 3600, 3600 * 24 };

		String[] strT = strValue.split(":");

		int j = 0;
		for (int i = strT.length - 1; i >= 0; i--) {
			intSeconds += new Integer(strT[i]) * intM[j++];
		}

		return intSeconds;
	}  // public int getTimeAsSeconds()
}
