/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "sqlutil"
//#define COPYRIGHT   "1996 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

#include "../kram/sosstrng.h"
#include "../kram/sos.h"
#include "../file/anyfile.h"
#include "../kram/dynobj.h"
#include "../kram/stdfield.h"       // Text_type

using namespace std;
namespace sos {

//-------------------------------------------------------------------------------get_single_row

Dyn_obj get_single_row( const Sos_string& stmt, const Dyn_obj& param )
{
    Dyn_obj             o;
    Sos_ptr<Field_type> type;
    Record_type         param_record_type;    // muss close() gltig sein!
    Any_file            f;
    Dynamic_area        buffer;

    f.prepare( stmt, Any_file::Open_mode( Any_file::in | Any_file::seq ) );

    if( param.type() ) {
        if( !param.type()->obj_is_type( tc_Record_type ) ) {
            param_record_type.add_field( param.type(), "field", 0 );
            f.bind_parameters( &param_record_type, param.ptr() );
        } else {
            //Sos_ptr<Record_type> record_type = Record_type::create();
            //record_type->add_field( param.type(), "param1", 0 );
            //f.bind_parameters( SOS_CAST( Record_type, record_type ), param.ptr() );
            f.bind_parameters( SOS_CAST( Record_type, param.type() ), param.ptr() );
        }
    }

    f.open();


    try {
        f.get( &buffer );
    }
    catch( const Eof_error& )  { throw_not_found_error( "SOS-1251", &param ); }

    type = f.spec()._field_type_ptr;

    if( !type ) {
        // Text wird angenommen, oder besser Binary_type?
        // Binary_type, der als Text interpretiert wird, wenn nur abdruckbare Zeichen drin sind?
        Sos_ptr<Text_type> p = SOS_NEW( Text_type( buffer.length() ) );
        type = +p;
    }

    o.assign( type, buffer );

    f.close();

    return o;
}

} //namespace sos
