/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#ifndef SYSTEM_GNU
#define MODULE_NAME "videocur"
//                                                      (c) SOS GmbH Berlin
//                                                          Joacim Zschimmer

#include <sysdep.h>
#if defined SYSTEM_LINUX

#include <stdlib.h>
#include <string.h>

#include <sos.h>
#include <sosstore.h>

#include "videocur.h"
#include <curses.h>


//------------------------------------------------------------------curses_attr

uint4 curses_attr( Video_attr attr )
{
    return 0;
}

//---------------------------------------------------Video_curses::Video_curses

Video_curses::Video_curses()
{
    _curses_window_ptr = initscr();
    cbreak();
    noecho();

    //??:
    nonl();
    //ncurses: intrflush( stdscr, FALSE );
    //ncurses: keypad( stdscr, TRUE );

    scrollok( ((WINDOW*)_curses_window_ptr), true );
}

//--------------------------------------------------Video_curses::~Video_curses

Video_curses::~Video_curses()
{
    endwin();
}

//-----------------------------------------------------Video_curses::set_cursor

void Video_curses::set_cursor( Video_pos pos )
{
    /*::*/move( pos.line0(), pos.column0() );
}

//-----------------------------------------------------------------Video::write

void Video::write( Video_pos pos, char c, Video_attr attr )
{
    set_cursor( pos );
    addch( curses_attr( attr ) | c );
}

//-----------------------------------------------------------------Video::write
/*
void Video::write( Video_pos pos, char* text, int len, Video_attr attr )
{
    set_cursor( pos );
    addchnstr( ... );
}
*/
//------------------------------------------------------------------Video::fill
/*
void Video::fill( Video_pos pos, char c, int len, Video_attr attr )
{
    char filler [ video_line_length ];

    memset( filler, c, sizeof filler );

    while( len > 0 ) {
        int l = min( len, video_line_length - pos.column0() );
        write( pos, filler, l, attr );
        len -= l;
        pos = pos.offset() + l;
    }
}
*/
//--------------------------------------------------------------------------------------Video::move

#undef move         // curses.h
#if 0

void Video::move( int wohin, int woher, int anzahl )
{
    WINDOW* w = newwin( max( wohin, woher ) + anzahl, video_line_length, min( wohin, woher ), 0 );
    wscrl( w, anzahl );
    delwin( w );
}

#endif
//--------------------------------------------------------------------------------------Video::sync

void Video::sync()
{
    refresh();
}


#endif
#endif
