/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: java_subsystem.h 14094 2010-10-20 11:28:15Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#ifndef __SCHEDULER_JAVA_SUBSYSTEM_H
#define __SCHEDULER_JAVA_SUBSYSTEM_H

#include "javaproxy.h"

namespace sos {
namespace scheduler {

//-----------------------------------------------------------------------Java_subsystem_interface

struct Java_subsystem_interface : Object, Subsystem
{
                                Java_subsystem_interface    ( Scheduler* scheduler, Type_code t )   : Subsystem( scheduler, this, t ) {}

    virtual javabridge::Vm*     java_vm                     ()                                      = 0;
    virtual void            set_java_options                ( const string& )                       = 0;
    virtual void                prepend_class_path          ( const string& )                       = 0;
    virtual SchedulerJ&         schedulerJ                  ()                                      = 0;
  //virtual const PlatformJ&    platformJ                   () const                                = 0;
    virtual xml::Element_ptr    dom_element                 (const xml::Document_ptr&)              = 0;

    static string               classname_of_scheduler_object(const string&);
    static ptr<javabridge::Java_idispatch>  instance_of_scheduler_object( IDispatch*, const string&);
};

//-------------------------------------------------------------------------------------------------

ptr<Java_subsystem_interface>   new_java_subsystem          ( Scheduler* );

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
