/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id$

#include "java.h"
#include "Proxy_class.h"

namespace zschimmer {
namespace javabridge {

//-------------------------------------------------------------------------Proxy_class::Proxy_class

Proxy_class::Proxy_class(const string& class_name) 
:
    Class(class_name),
    _constructor(this, Parameter_list_signature::of_types(t_void, "com.sos.scheduler.engine.cplusplus.runtime.Sister")),
    _cppReference_field(this, "cppReference", Simple_signature::of_type(t_long)),
    _invalidateCppReference_method(this, "invalidateCppReference", Parameter_list_signature::of_types(t_void)),
    _getSister_method(this, "getSister", Parameter_list_signature::of_types("com.sos.scheduler.engine.cplusplus.runtime.Sister"))
{
}

//------------------------------------------------------------------------Proxy_class::~Proxy_class
    
Proxy_class::~Proxy_class() 
{
}

//------------------------------------------------------------------------Proxy_class::new_instance
    
jobject Proxy_class::new_instance(jobject context_CppProxy) const
{ 
    jobject result = alloc_object();
    Parameters p (context_CppProxy);
    _constructor.call(result, p); 
    return result;
}

//---------------------------------------------------------Java_proxy:class::set_reference_in_proxy

void Proxy_class::set_reference_in_proxy(jobject jo, jlong value) const
{
    if (value == 0) 
        _invalidateCppReference_method.call(jo);
    else
        _cppReference_field.set_long( jo, value );
}

//---------------------------------------------------------------------------Proxy_class::getSister

Global_jobject2 Proxy_class::getSister(jobject jo) const
{
    Global_jobject2 result;
    result.steal_local_ref( _getSister_method.jobject_call(jo) );
    return result;
}

//-------------------------------------------------------------------------------------------------

} //namespace javabridge
} //namespace zschimmer

